//
//  main.m
//  traceWrite
//
//  Created by 今井 彰彦 on 2011/12/05
//  Copyright 2011 AIG-Soft. All rights reserved.
//

#import	"main.h"
#import "AppDelegate.h"
#import <UIKit/UIKit.h>

// グローバル(的)変数
BOOL		fnonActive=NO;		// nonActiveになったかどうか
BOOL		ffirst;				// 初回起動かどうか
BOOL		fRotaionLock=NO;	// YES=回転禁止

// プログラム名
NSString *programVersion,*programName;

int main(int argc, char *argv[])
{
    @autoreleasepool {
	//
	// plistからプログラム名とバージョンを得ておく
		programName=[[[NSBundle mainBundle]infoDictionary]objectForKey:(NSString *)kCFBundleNameKey]; // これは常に日本語名なので注意
		nslog(@"programName=%@",programName);
		programVersion=[[[NSBundle mainBundle]infoDictionary]objectForKey:(NSString *)kCFBundleVersionKey];
		nslog(@"programVersion=%@",programVersion);
		//
		// defaultデータベースに書きこむ；これにより、iOS設定でこれらの値が読めるようになる
		// Root.plistに書くkey名(Identifier)はdefault内のキー名またはRoot.strings内のキー名である
		// ただし、現在読んでいるのはバージョンのみ
		NSUserDefaults *defaults=[NSUserDefaults standardUserDefaults];
		[defaults setObject:programName	   forKey:keyProgramName];
		[defaults setObject:programVersion forKey:keyProgramVersion];
		//
#if 0	//!!test!! : 全フォント名を表示する
		NSArray *namesArray=[NSArray arrayWithArray:[UIFont familyNames]];
		NSEnumerator *emu=[namesArray objectEnumerator];
		NSString *name;
		while (name=[emu nextObject]) {
			nslog(@"Font familyNames=%@",name);
			NSArray *namesArray2=[NSArray arrayWithArray:[UIFont fontNamesForFamilyName:name]];
			NSEnumerator *emu2=[namesArray2 objectEnumerator];
			NSString *name2;
			while (name2=[emu2 nextObject]) {
				nslog(@"+-Font fontNames=%@",name2);
			}
		}
#endif
		return UIApplicationMain(argc, argv, nil, NSStringFromClass([AppDelegate class]));
    }
}

// 画面回転の許可条件(iOS6)
// okInterfaceOrientation()に合わせる
NSUInteger supportedInterfaceOrientationsByMain(void)
{
#if 0
	typedef NS_OPTIONS(NSUInteger, UIInterfaceOrientationMask) {
		UIInterfaceOrientationMaskPortrait,
		UIInterfaceOrientationMaskLandscapeLeft,
		UIInterfaceOrientationMaskLandscapeRight,
		UIInterfaceOrientationMaskPortraitUpsideDown,
		UIInterfaceOrientationMaskLandscape,
		UIInterfaceOrientationMaskAll,
		UIInterfaceOrientationMaskAllButUpsideDown,
	};
#endif
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
		// iPadは全方向
		// これが↓なら、shouldAutorotateByMainは呼び出されないようである
		return UIInterfaceOrientationMaskAll;
	}
	// iPhoneは縦のみ
	return UIInterfaceOrientationMaskPortrait|UIInterfaceOrientationMaskPortraitUpsideDown;
}

// iOS6
BOOL shouldAutorotateByMain(void)
{
	///	nslog(@"shouldAutorotateByMain:fRotaionLock=%d",fRotaionLock);
	if (!fRotaionLock) {
		return YES;
	}
	return NO;
}

